Home | History | Annotate | Download | only in cloneNS
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test05} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST05***************"
     29 tst_resm TINFO "cloneNS: namespace with multi-level "
     30 tst_resm TINFO "chain of slaves"
     31 tst_resm TINFO "************************************"
     32 
     33 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of cloneNS/test05 failed" && tst_exit)
     34 export result=0
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 	cp "${FS_BIND_ROOT}/cloneNS/parent05" ./
     43 	cp "${FS_BIND_ROOT}/cloneNS/child05" .
     44 
     45 	chmod 755 parent05 child05
     46 
     47 
     48 	"${FS_BIND_ROOT}/bin/makedir" share parent
     49 	"${FS_BIND_ROOT}/bin/makedir" share parent/child1
     50 	"${FS_BIND_ROOT}/bin/makedir" share parent/child2
     51 
     52 	mount --rbind "$disk1" parent/child1
     53 
     54 	mount --rbind parent parent/child2/
     55 
     56 	"${FS_BIND_ROOT}/bin/nsclone" ./parent05 ./child05 || result=$?
     57 
     58 	break
     59 done
     60 trap 'ERR=$? ; tst_resm TWARN "cloneNS/test05: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     61 if [ -n "${ERR_MSG}" ]; then
     62 	tst_resm TWARN "cloneNS/test05: ${ERR_MSG}"
     63 	ERR_MSG=""
     64 	result=$ERR
     65 fi
     66 trap '' ERR
     67 {
     68 	umount parent/child2/child2
     69 	umount parent/child2/child1/a
     70 	umount parent/child2/child1/c
     71 	umount parent/child2/child1
     72 	umount parent/child2/child1
     73 	umount parent/child2
     74 	umount parent/child2
     75 	umount parent
     76 
     77 	rm -rf parent* child*
     78 
     79 	cleanup
     80 } >& /dev/null
     81 if [ $result -ne 0 ]
     82 then
     83 	tst_resm TFAIL "cloneNS/test05: FAILED: cloneNS: namespace with multi-level
     84 chain of slaves"
     85 	exit 1
     86 else
     87 	tst_resm TPASS "cloneNS/test05: PASSED"
     88 	exit 0
     89 fi
     90 tst_exit
     91